/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
	      programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

int
vigenere (char *org, char *key)
{

  unsigned int itra = 0, itrb = 0, itrc = 0, pad = 0, sem = 0;
  char *hlpr[strlen (key)];
  char *dst;

  if (!strlen (key))
    return KEYB;

  for (itra = 0; itra < strlen (key); itra++)
    if (isdigit (key[itra]))
      return KEYB;

  dst = (char *) calloc (strlen (org), sizeof (char));

  for (itra = 0; itra < strlen (key); itra++)
    {
      hlpr[itra] = (char *) malloc ('z' - 'a');
      for (itrb = 0, pad = 0; itrb <= 25; itrb++)
	{
	  if (key[itra] + pad > 'z')
	    pad = ('a' - key[itra]);
	  hlpr[itra][itrb] = key[itra] + (pad++);
	}
    }

  strcpy (dst, org);

  for (itra = 0, itrc = 0; itra < strlen (org) - 1; itra++)
    {
      if (itrc >= strlen (key))
	itrc = 0;
      if (isupper (org[itra]))
	{
	  org[itra] = tolower (org[itra]);
	  sem++;
	}
      if (!isalpha (org[itra]))
	{
	  dst[itra] = org[itra];
	  itrc = 0;
	}
      else
	{
	  if (!al_dec)
	    dst[itra] = hlpr[itrc++][org[itra] - 'a'];
	  else if (al_dec)
	    {
	      for (itrb = 0; itrb < strlen (hlpr[itrc]); itrb++)
		{
		  if (hlpr[itrc][itrb] == org[itra])
		    dst[itra] = itrb + 'a';
		}
	      itrc++;
	    }
	  if (sem)
	    {
	      dst[itra] = toupper (dst[itra]);
	      sem--;
	    }
	}
    }

  strncpy (org, dst, strlen (dst));
  free (dst);

  return 0;
}
